hdu 1087 Super Jumping! Jumping! Jumping! 最大上升子序列。模

Super Jumping! Jumping! Jumping!Time Limit: 2000/1000 MS (Java/Others)Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 24374Accepted Submission(s): 10740

Problem Description

Nowadays, a kind of chess game called “Super Jumping! Jumping! Jumping!” is very popular in HDU. Maybe you are a good boy, and know little about this game, so I introduce it to you now.The game can be played by two or more than two players. It consists of a chessboard(棋盘)and some chessmen(棋子), and all chessmen are marked by a positive integer or “start” or “end”. The player starts from start-point and must jumps into end-point finally. In the course of jumping, the player will visit the chessmen in the path, but everyone must jumps from one chessman to another absolutely bigger (you can assume start-point is a minimum and end-point is a maximum.). And all players cannot go backwards. One jumping can go from a chessman to next, also can go across many chessmen, and even you can straightly get to end-point from start-point. Of course you get zero point in this situation. A player is a winner if and only if he can get a bigger score according to his jumping solution. Note that your score comes from the sum of value on the chessmen in you jumping path.Your task is to output the maximum value according to the given chessmen list.

Input

Input contains multiple test cases. Each test case is described in a line as follow:N value_1 value_2 …value_N It is guarantied that N is not more than 1000 and all value_i are in the range of 32-int.A test case starting with 0 terminates the input and this test case is not to be processed.

Output

For each case, print the maximum according to rules, and one line one case.

Sample Input

3 1 3 24 1 2 3 44 3 3 2 10

Sample Output

4103

先写上状态转移公式:dp[i]=max{dp[j]+num[i]}(num[i]>num[j],j<i);

i代表以第i个数结尾的最大上升子序列的和。

突然感觉没什么说的了,那就上代码吧。

#include <stdio.h>#define INF 100000000#define MAX 1010int max(int a , int b){return a>b?a:b ;}int main(){int dp[MAX],num[MAX] , n;while(~scanf("%d",&n) && n){for(int i = 1 ; i <= n ; ++i){scanf("%d",&num[i]) ;dp[i] = 0 ;}dp[0] = 0 ;int ans = -INF ;for(int i = 1 ; i <= n ; ++i){dp[i]=num[i];for(int j = 1 ; j <= i ; ++j){if(num[j]<num[i]){dp[i] = max(dp[i],dp[j]+num[i]) ;}}ans = max(ans , dp[i]) ;}printf("%d\n",ans) ;}return 0 ;}我喜欢DP的原因,就是因为它简单明了,把一个很原本复杂的问题,解决的如此完美和简洁。

,生活是一段奇妙的旅行,就在那一去无返的火车上。

hdu 1087 Super Jumping! Jumping! Jumping! 最大上升子序列。模

相关文章:

你感兴趣的文章:

标签云: